Index: /trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- /trunk/sources/HeuristicLab 3.3.sln	(revision 14845)
+++ /trunk/sources/HeuristicLab 3.3.sln	(revision 14846)
@@ -93,4 +93,5 @@
 		{B94FFB82-43D4-40AB-9980-B03470ADF221} = {B94FFB82-43D4-40AB-9980-B03470ADF221}
 		{06D4A186-9319-48A0-BADE-A2058D462EEA} = {06D4A186-9319-48A0-BADE-A2058D462EEA}
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9} = {4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}
 		{5B9B9E8C-2706-43C2-80B8-A08341E431F7} = {5B9B9E8C-2706-43C2-80B8-A08341E431F7}
 		{997F018D-AEA2-4F21-9301-82FAF6A5612D} = {997F018D-AEA2-4F21-9301-82FAF6A5612D}
@@ -449,4 +450,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.BinPacking-3.3", "HeuristicLab.Problems.BinPacking\3.3\HeuristicLab.Problems.BinPacking-3.3.csproj", "{F8A55094-3CD5-4034-B0CA-5BD7FFB016D4}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.DataAnalysis.Glmnet", "HeuristicLab.Algorithms.DataAnalysis.Glmnet\3.4\HeuristicLab.Algorithms.DataAnalysis.Glmnet.csproj", "{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}"
 EndProject
 Global
@@ -2188,4 +2191,16 @@
 		{F8A55094-3CD5-4034-B0CA-5BD7FFB016D4}.Release|x86.ActiveCfg = Release|x86
 		{F8A55094-3CD5-4034-B0CA-5BD7FFB016D4}.Release|x86.Build.0 = Release|x86
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Debug|x64.ActiveCfg = Debug|x64
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Debug|x64.Build.0 = Debug|x64
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Debug|x86.ActiveCfg = Debug|x86
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Debug|x86.Build.0 = Debug|x86
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Release|Any CPU.Build.0 = Release|Any CPU
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Release|x64.ActiveCfg = Release|x64
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Release|x64.Build.0 = Release|x64
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Release|x86.ActiveCfg = Release|x86
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Build.cmd
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Build.cmd	(revision 14846)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Build.cmd	(revision 14846)
@@ -0,0 +1,104 @@
+@ECHO OFF
+
+SET CLEANBEFOREBUILD=
+
+SET SELECTED=
+SET CONFIGURATION=
+SET PLATFORM=
+
+IF "%~1"=="" GOTO :prompt_solution
+
+SET SELECTED=%1
+IF NOT EXIST %SELECTED% (
+  ECHO Solution file %SELECTED% could not be found.
+  GOTO :end
+)
+ECHO Building solution %SELECTED% ...
+GOTO :config_selection
+
+:prompt_solution
+SET /A COUNT=0
+FOR /F "tokens=*" %%A IN ('dir /B *.sln') DO (
+  CALL :forloopbody "%%A"
+)
+
+IF "%COUNT%"=="1" (
+  SET SELECTED=%SOLUTIONS.1%
+  ECHO Building %SOLUTIONS.1% as it is the only solution that was found ...
+  GOTO :config_selection
+)
+
+ECHO Found the following solutions:
+FOR /F "tokens=2* delims=.=" %%A IN ('SET SOLUTIONS.') DO ECHO %%A = %%B
+ECHO.
+SET /P SOLUTIONINDEX=Which solution to build? Type the number: 
+
+SET SELECTED=""
+FOR /F "tokens=2* delims=.=" %%A IN ('SET SOLUTIONS.') DO (
+  IF "%%A"=="%SOLUTIONINDEX%" SET SELECTED=%%B
+)
+
+IF %SELECTED%=="" GOTO :eof
+
+:config_selection
+IF "%~2"==""  GOTO :prompt_config
+
+SET CONFIGURATION=%~2
+ECHO Building configuration %CONFIGURATION% ...
+GOTO :platform_selection
+
+:prompt_config
+SET /P CONFIGURATION=Which configuration to build [Release]: 
+IF "%CONFIGURATION%"=="" SET CONFIGURATION=Release
+
+:platform_selection
+IF "%~3"=="" GOTO :prompt_platform
+  
+SET PLATFORM=%~3
+ECHO Building platform %PLATFORM% ...
+GOTO :clean
+
+:prompt_platform
+SET /P PLATFORM=Which platform to build [Any CPU]: 
+IF "%PLATFORM%"=="" SET PLATFORM=Any CPU
+
+:clean
+IF "%~4"=="" GOTO :prompt_clean
+
+SET CLEANBEFOREBUILD=%~4
+GOTO :main
+
+:prompt_clean
+SET /P CLEANBEFOREBUILD=Would you like to clean before building [n]: 
+IF "%CLEANBEFOREBUILD%"=="" SET CLEANBEFOREBUILD=n
+
+:main
+REM First find the path to the msbuild.exe by performing a registry query
+FOR /F "tokens=1,3 delims=	 " %%A IN ('REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\MSBuild\ToolsVersions\4.0"') DO (
+  IF "%%A"=="MSBuildToolsPath" SET MSBUILDPATH=%%B)
+
+REM Then execute msbuild to clean and build the solution
+REM Disable that msbuild creates a cache file of the solution
+SET MSBuildUseNoSolutionCache=1
+REM Run msbuild to clean and then build
+IF "%CLEANBEFOREBUILD%" NEQ "n" (
+  ECHO Cleaning ...
+  %MSBUILDPATH%msbuild.exe %SELECTED% /target:Clean /p:Configuration="%CONFIGURATION%",Platform="%PLATFORM%" /m:2 /nologo /verbosity:q /clp:ErrorsOnly
+)
+ECHO Building ...
+%MSBUILDPATH%msbuild.exe %SELECTED% /target:Build /p:Configuration="%CONFIGURATION%",Platform="%PLATFORM%" /m:2 /nologo /verbosity:q /clp:ErrorsOnly
+
+ECHO.
+ECHO DONE.
+
+:end
+
+PAUSE
+
+GOTO :eof
+
+REM This workaround is necessary so that COUNT gets reevaluated
+:forloopbody
+SET /A COUNT+=1
+SET SOLUTIONS.%COUNT%=%1
+GOTO :eof
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/ElasticNetLinearRegression.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/ElasticNetLinearRegression.cs	(revision 14846)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/ElasticNetLinearRegression.cs	(revision 14846)
@@ -0,0 +1,346 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+
+namespace HeuristicLab.Algorithms.DataAnalysis.Glmnet {
+  [Item("Elastic-net Linear Regression (LR)", "Linear regression with elastic-net regularization (wrapper for glmnet)")]
+  [Creatable(CreatableAttribute.Categories.DataAnalysisRegression, Priority = 110)]
+  [StorableClass]
+  public sealed class ElasticNetLinearRegression : FixedDataAnalysisAlgorithm<IRegressionProblem> {
+    private const string PenalityParameterName = "Penality";
+    private const string LambdaParameterName = "Lambda";
+    #region parameters
+    public IFixedValueParameter<DoubleValue> PenalityParameter {
+      get { return (IFixedValueParameter<DoubleValue>)Parameters[PenalityParameterName]; }
+    }
+    public IValueParameter<DoubleValue> LambdaParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters[LambdaParameterName]; }
+    }
+    #endregion
+    #region properties
+    public double Penality {
+      get { return PenalityParameter.Value.Value; }
+      set { PenalityParameter.Value.Value = value; }
+    }
+    public DoubleValue Lambda {
+      get { return LambdaParameter.Value; }
+      set { LambdaParameter.Value = value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private ElasticNetLinearRegression(bool deserializing) : base(deserializing) { }
+    private ElasticNetLinearRegression(ElasticNetLinearRegression original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public ElasticNetLinearRegression()
+      : base() {
+      Problem = new RegressionProblem();
+      Parameters.Add(new FixedValueParameter<DoubleValue>(PenalityParameterName, "Penalty factor (alpha) for balancing between ridge (0.0) and lasso (1.0) regression", new DoubleValue(0.5)));
+      Parameters.Add(new OptionalValueParameter<DoubleValue>(LambdaParameterName, "Optional: the value of lambda for which to calculate an elastic-net solution. lambda == null => calculate the whole path of all lambdas"));
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ElasticNetLinearRegression(this, cloner);
+    }
+
+    protected override void Run(CancellationToken cancellationToken) {
+      if (Lambda == null) {
+        CreateSolutionPath();
+      } else {
+        CreateSolution(Lambda.Value);
+      }
+    }
+
+    private void CreateSolution(double lambda) {
+      double trainNMSE;
+      double testNMSE;
+      var coeff = CreateElasticNetLinearRegressionSolution(Problem.ProblemData, Penality, lambda, out trainNMSE, out testNMSE);
+      Results.Add(new Result("NMSE (train)", new DoubleValue(trainNMSE)));
+      Results.Add(new Result("NMSE (test)", new DoubleValue(testNMSE)));
+
+      var allVariables = Problem.ProblemData.AllowedInputVariables.ToArray();
+
+      var remainingVars = Enumerable.Range(0, allVariables.Length)
+        .Where(idx => !coeff[idx].IsAlmost(0.0)).Select(idx => allVariables[idx])
+        .ToArray();
+      var remainingCoeff = Enumerable.Range(0, allVariables.Length)
+        .Select(idx => coeff[idx])
+        .Where(c => !c.IsAlmost(0.0))
+        .ToArray();
+
+      var tree = LinearModelToTreeConverter.CreateTree(remainingVars, remainingCoeff, coeff.Last());
+
+
+      SymbolicRegressionSolution solution = new SymbolicRegressionSolution(
+        new SymbolicRegressionModel(Problem.ProblemData.TargetVariable, tree, new SymbolicDataAnalysisExpressionTreeInterpreter()),
+        (IRegressionProblemData)Problem.ProblemData.Clone());
+      solution.Model.Name = "Elastic-net Linear Regression Model";
+      solution.Name = "Elastic-net Linear Regression Solution";
+
+      Results.Add(new Result(solution.Name, solution.Description, solution));
+    }
+
+    private void CreateSolutionPath() {
+      double[] lambda;
+      double[] trainNMSE;
+      double[] testNMSE;
+      double[,] coeff;
+      double[] intercept;
+      RunElasticNetLinearRegression(Problem.ProblemData, Penality, out lambda, out trainNMSE, out testNMSE, out coeff, out intercept);
+
+      var coeffTable = new IndexedDataTable<double>("Coefficients", "The paths of standarized coefficient values over different lambda values");
+      coeffTable.VisualProperties.YAxisMaximumAuto = false;
+      coeffTable.VisualProperties.YAxisMinimumAuto = false;
+      coeffTable.VisualProperties.XAxisMaximumAuto = false;
+      coeffTable.VisualProperties.XAxisMinimumAuto = false;
+
+      coeffTable.VisualProperties.XAxisLogScale = true;
+      coeffTable.VisualProperties.XAxisTitle = "Lambda";
+      coeffTable.VisualProperties.YAxisTitle = "Coefficients";
+      coeffTable.VisualProperties.SecondYAxisTitle = "Number of variables";
+
+      var nLambdas = lambda.Length;
+      var nCoeff = coeff.GetLength(1);
+      var dataRows = new IndexedDataRow<double>[nCoeff];
+      var allowedVars = Problem.ProblemData.AllowedInputVariables.ToArray();
+      var numNonZeroCoeffs = new int[nLambdas];
+      for (int i = 0; i < nCoeff; i++) {
+        var coeffId = allowedVars[i];
+        double sigma = Problem.ProblemData.Dataset.GetDoubleValues(coeffId).StandardDeviation();
+        var path = Enumerable.Range(0, nLambdas).Select(r => Tuple.Create(lambda[r], coeff[r, i] * sigma)).ToArray();
+        dataRows[i] = new IndexedDataRow<double>(coeffId, coeffId, path);
+      }
+      // add to coeffTable by total weight (larger area under the curve => more important);
+      foreach (var r in dataRows.OrderByDescending(r => r.Values.Select(t => t.Item2).Sum(x => Math.Abs(x)))) {
+        coeffTable.Rows.Add(r);
+      }
+
+      for (int i = 0; i < coeff.GetLength(0); i++) {
+        for (int j = 0; j < coeff.GetLength(1); j++) {
+          if (!coeff[i, j].IsAlmost(0.0)) {
+            numNonZeroCoeffs[i]++;
+          }
+        }
+      }
+      if (lambda.Length > 2) {
+        coeffTable.VisualProperties.XAxisMinimumFixedValue = Math.Pow(10, Math.Floor(Math.Log10(lambda.Last())));
+        coeffTable.VisualProperties.XAxisMaximumFixedValue = Math.Pow(10, Math.Ceiling(Math.Log10(lambda.Skip(1).First())));
+      }
+      coeffTable.Rows.Add(new IndexedDataRow<double>("Number of variables", "The number of non-zero coefficients for each step in the path", lambda.Zip(numNonZeroCoeffs, (l, v) => Tuple.Create(l, (double)v))));
+      coeffTable.Rows["Number of variables"].VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Points;
+      coeffTable.Rows["Number of variables"].VisualProperties.SecondYAxis = true;
+
+      Results.Add(new Result(coeffTable.Name, coeffTable.Description, coeffTable));
+
+      var errorTable = new IndexedDataTable<double>("NMSE", "Path of NMSE values over different lambda values");
+      errorTable.VisualProperties.YAxisMaximumAuto = false;
+      errorTable.VisualProperties.YAxisMinimumAuto = false;
+      errorTable.VisualProperties.XAxisMaximumAuto = false;
+      errorTable.VisualProperties.XAxisMinimumAuto = false;
+
+      errorTable.VisualProperties.YAxisMinimumFixedValue = 0;
+      errorTable.VisualProperties.YAxisMaximumFixedValue = 1.0;
+      errorTable.VisualProperties.XAxisLogScale = true;
+      errorTable.VisualProperties.XAxisTitle = "Lambda";
+      errorTable.VisualProperties.YAxisTitle = "Normalized mean of squared errors (NMSE)";
+      errorTable.VisualProperties.SecondYAxisTitle = "Number of variables";
+      errorTable.Rows.Add(new IndexedDataRow<double>("NMSE (train)", "Path of NMSE values over different lambda values", lambda.Zip(trainNMSE, (l, v) => Tuple.Create(l, v))));
+      errorTable.Rows.Add(new IndexedDataRow<double>("NMSE (test)", "Path of NMSE values over different lambda values", lambda.Zip(testNMSE, (l, v) => Tuple.Create(l, v))));
+      errorTable.Rows.Add(new IndexedDataRow<double>("Number of variables", "The number of non-zero coefficients for each step in the path", lambda.Zip(numNonZeroCoeffs, (l, v) => Tuple.Create(l, (double)v))));
+      if (lambda.Length > 2) {
+        errorTable.VisualProperties.XAxisMinimumFixedValue = Math.Pow(10, Math.Floor(Math.Log10(lambda.Last())));
+        errorTable.VisualProperties.XAxisMaximumFixedValue = Math.Pow(10, Math.Ceiling(Math.Log10(lambda.Skip(1).First())));
+      }
+      errorTable.Rows["NMSE (train)"].VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Points;
+      errorTable.Rows["NMSE (test)"].VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Points;
+      errorTable.Rows["Number of variables"].VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Points;
+      errorTable.Rows["Number of variables"].VisualProperties.SecondYAxis = true;
+
+      Results.Add(new Result(errorTable.Name, errorTable.Description, errorTable));
+    }
+
+    public static double[] CreateElasticNetLinearRegressionSolution(IRegressionProblemData problemData, double penalty, double lambda,
+            out double trainNMSE, out double testNMSE,
+            double coeffLowerBound = double.NegativeInfinity, double coeffUpperBound = double.PositiveInfinity) {
+      double[] trainNMSEs;
+      double[] testNMSEs;
+      // run for exactly one lambda
+      var coeffs = CreateElasticNetLinearRegressionSolution(problemData, penalty, new double[] { lambda }, out trainNMSEs, out testNMSEs, coeffLowerBound, coeffUpperBound);
+      trainNMSE = trainNMSEs[0];
+      testNMSE = testNMSEs[0];
+      return coeffs[0];
+    }
+    public static double[][] CreateElasticNetLinearRegressionSolution(IRegressionProblemData problemData, double penalty, double[] lambda,
+            out double[] trainNMSEs, out double[] testNMSEs,
+            double coeffLowerBound = double.NegativeInfinity, double coeffUpperBound = double.PositiveInfinity,
+            int maxVars = -1) {
+      // run for multiple user-supplied lambdas
+      double[,] coeff;
+      double[] intercept;
+      RunElasticNetLinearRegression(problemData, penalty, lambda.Length, 1.0, lambda, out lambda, out trainNMSEs, out testNMSEs, out coeff, out intercept, coeffLowerBound, coeffUpperBound, maxVars);
+
+      int nRows = intercept.Length;
+      int nCols = coeff.GetLength(1) + 1;
+      double[][] sols = new double[nRows][];
+      for (int solIdx = 0; solIdx < nRows; solIdx++) {
+        sols[solIdx] = new double[nCols];
+        for (int cIdx = 0; cIdx < nCols - 1; cIdx++) {
+          sols[solIdx][cIdx] = coeff[solIdx, cIdx];
+        }
+        sols[solIdx][nCols - 1] = intercept[solIdx];
+      }
+      return sols;
+    }
+
+    public static void RunElasticNetLinearRegression(IRegressionProblemData problemData, double penalty,
+      out double[] lambda, out double[] trainNMSE, out double[] testNMSE, out double[,] coeff, out double[] intercept,
+      double coeffLowerBound = double.NegativeInfinity, double coeffUpperBound = double.PositiveInfinity,
+      int maxVars = -1
+      ) {
+      double[] userLambda = new double[0];
+      // automatically determine lambda values (maximum 100 different lambda values)
+      RunElasticNetLinearRegression(problemData, penalty, 100, 0.0, userLambda, out lambda, out trainNMSE, out testNMSE, out coeff, out intercept, coeffLowerBound, coeffUpperBound, maxVars);
+    }
+
+    /// <summary>
+    /// Elastic net with squared-error-loss for dense predictor matrix, runs the full path of all lambdas
+    /// </summary>
+    /// <param name="problemData">Predictor target matrix x and target vector y</param>
+    /// <param name="penalty">Penalty for balance between ridge (0.0) and lasso (1.0) regression</param>
+    /// <param name="nlam">Maximum number of lambda values (default 100)</param>
+    /// <param name="flmin">User control of lambda values (&lt;1.0 => minimum lambda = flmin * (largest lambda value), >= 1.0 => use supplied lambda values</param>
+    /// <param name="ulam">User supplied lambda values</param>
+    /// <param name="lambda">Output lambda values</param>
+    /// <param name="trainNMSE">Vector of normalized mean of squared error (NMSE = Variance(res) / Variance(y)) values on the training set for each set of coefficients along the path</param>
+    /// <param name="testNMSE">Vector of normalized mean of squared error (NMSE = Variance(res) / Variance(y)) values on the test set for each set of coefficients along the path</param>
+    /// <param name="coeff">Vector of coefficient vectors for each solution along the path</param>
+    /// <param name="intercept">Vector of intercepts for each solution along the path</param>
+    /// <param name="coeffLowerBound">Optional lower bound for all coefficients</param>
+    /// <param name="coeffUpperBound">Optional upper bound for all coefficients</param>
+    /// <param name="maxVars">Maximum allowed number of variables in each solution along the path (-1 => all variables are allowed)</param>
+    private static void RunElasticNetLinearRegression(IRegressionProblemData problemData, double penalty,
+  int nlam, double flmin, double[] ulam, out double[] lambda, out double[] trainNMSE, out double[] testNMSE, out double[,] coeff, out double[] intercept,
+  double coeffLowerBound = double.NegativeInfinity, double coeffUpperBound = double.PositiveInfinity,
+  int maxVars = -1
+  ) {
+      if (penalty < 0.0 || penalty > 1.0) throw new ArgumentException("0 <= penalty <= 1", "penalty");
+
+      double[,] trainX;
+      double[,] testX;
+      double[] trainY;
+      double[] testY;
+
+      PrepareData(problemData, out trainX, out trainY, out testX, out testY);
+      var numTrainObs = trainX.GetLength(1);
+      var numTestObs = testX.GetLength(1);
+      var numVars = trainX.GetLength(0);
+
+      int ka = 1; // => covariance updating algorithm
+      double parm = penalty;
+      double[] w = Enumerable.Repeat(1.0, numTrainObs).ToArray(); // all observations have the same weight
+      int[] jd = new int[1]; // do not force to use any of the variables
+      double[] vp = Enumerable.Repeat(1.0, numVars).ToArray(); // all predictor variables are unpenalized
+      double[,] cl = new double[numVars, 2]; // use the same bounds for all coefficients
+      for (int i = 0; i < numVars; i++) {
+        cl[i, 0] = coeffLowerBound;
+        cl[i, 1] = coeffUpperBound;
+      }
+
+      int ne = maxVars > 0 ? maxVars : numVars;
+      int nx = numVars;
+      double thr = 1.0e-5; // default value as recommended in glmnet
+      int isd = 1; //  => regression on standardized predictor variables
+      int intr = 1;  // => do include intercept in model
+      int maxit = 100000; // default value as recommended in glmnet
+      // outputs
+      int lmu = -1;
+      double[,] ca;
+      int[] ia;
+      int[] nin;
+      int nlp = -99;
+      int jerr = -99;
+      double[] trainR2;
+      Glmnet.elnet(ka, parm, numTrainObs, numVars, trainX, trainY, w, jd, vp, cl, ne, nx, nlam, flmin, ulam, thr, isd, intr, maxit, out lmu, out intercept, out ca, out ia, out nin, out trainR2, out lambda, out nlp, out jerr);
+
+      trainNMSE = new double[lmu]; // elnet returns R**2 as 1 - NMSE
+      testNMSE = new double[lmu];
+      coeff = new double[lmu, numVars];
+      for (int solIdx = 0; solIdx < lmu; solIdx++) {
+        trainNMSE[solIdx] = 1.0 - trainR2[solIdx];
+
+        // uncompress coefficients of solution
+        int selectedNin = nin[solIdx];
+        double[] coefficients;
+        double[] selectedCa = new double[nx];
+        for (int i = 0; i < nx; i++) {
+          selectedCa[i] = ca[solIdx, i];
+        }
+
+        // apply to test set to calculate test NMSE values for each lambda step
+        double[] fn;
+        Glmnet.modval(intercept[solIdx], selectedCa, ia, selectedNin, numTestObs, testX, out fn);
+        OnlineCalculatorError error;
+        var nmse = OnlineNormalizedMeanSquaredErrorCalculator.Calculate(testY, fn, out error);
+        if (error != OnlineCalculatorError.None) nmse = double.NaN;
+        testNMSE[solIdx] = nmse;
+
+        // uncompress coefficients
+        Glmnet.uncomp(numVars, selectedCa, ia, selectedNin, out coefficients);
+        for (int i = 0; i < coefficients.Length; i++) {
+          coeff[solIdx, i] = coefficients[i];
+        }
+      }
+    }
+
+    private static void PrepareData(IRegressionProblemData problemData, out double[,] trainX, out double[] trainY,
+      out double[,] testX, out double[] testY) {
+
+      var ds = problemData.Dataset;
+      trainX = ds.ToArray(problemData.AllowedInputVariables, problemData.TrainingIndices);
+      trainX = trainX.Transpose();
+      trainY = problemData.Dataset.GetDoubleValues(problemData.TargetVariable,
+        problemData.TrainingIndices)
+        .ToArray();
+      testX = ds.ToArray(problemData.AllowedInputVariables, problemData.TestIndices);
+      testX = testX.Transpose();
+      testY = problemData.Dataset.GetDoubleValues(problemData.TargetVariable,
+        problemData.TestIndices)
+        .ToArray();
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Glmnet.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Glmnet.cs	(revision 14846)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Glmnet.cs	(revision 14846)
@@ -0,0 +1,301 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Runtime.InteropServices;
+
+namespace HeuristicLab.Algorithms.DataAnalysis.Glmnet {
+  public static class Glmnet {
+    /// <summary>Wrapper for elnet procedure in glmnet library</summary>
+    /// (see: https://cran.r-project.org/web/packages/glmnet/index.html)
+    /// 
+    ///  ka = algorithm flag
+    ///       ka=1 => covariance updating algorithm
+    ///       ka=2 => naive algorithm
+    ///  parm = penalty member index(0&lt;= parm &lt;= 1)
+    ///         = 0.0 => ridge
+    ///  = 1.0 => lasso
+    ///    no = number of observations
+    ///    ni = number of predictor variables
+    ///  y(no) = response vector(overwritten)
+    ///  w(no)= observation weights(overwritten)
+    ///  jd(jd(1)+1) = predictor variable deletion flag
+    ///  jd(1) = 0  => use all variables
+    ///       jd(1) != 0 => do not use variables jd(2)...jd(jd(1)+1)
+    ///  vp(ni) = relative penalties for each predictor variable
+    ///       vp(j) = 0 => jth variable unpenalized
+    ///    cl(2, ni) = interval constraints on coefficient values(overwritten)
+    ///  cl(1, j) = lower bound for jth coefficient value(&lt;= 0.0)
+    ///  cl(2, j) = upper bound for jth coefficient value(>= 0.0)
+    ///  ne = maximum number of variables allowed to enter largest model
+    /// (stopping criterion)
+    ///  nx = maximum number of variables allowed to enter all modesl
+    ///  along path(memory allocation, nx > ne).
+    ///  nlam = (maximum)number of lamda values
+    ///    flmin = user control of lamda values(>=0)
+    ///  flmin&lt; 1.0 => minimum lamda = flmin * (largest lamda value)
+    ///  flmin >= 1.0 => use supplied lamda values(see below)
+    ///  ulam(nlam) = user supplied lamda values(ignored if flmin&lt; 1.0)
+    ///  thr = convergence threshold for each lamda solution.
+    ///  iterations stop when the maximum reduction in the criterion value
+    ///       as a result of each parameter update over a single pass
+    ///       is less than thr times the null criterion value.
+    /// (suggested value, thr= 1.0e-5)
+    ///  isd = predictor variable standarization flag:
+    ///  isd = 0 => regression on original predictor variables
+    ///       isd = 1 => regression on standardized predictor variables
+    ///       Note: output solutions always reference original
+    ///             variables locations and scales.
+    ///    intr = intercept flag
+    ///       intr = 0 / 1 => don't/do include intercept in model
+    ///  maxit = maximum allowed number of passes over the data for all lambda
+    ///  values (suggested values, maxit = 100000)
+    /// 
+    ///  output:
+    /// 
+    ///    lmu = actual number of lamda values(solutions)
+    ///  a0(lmu) = intercept values for each solution
+    ///  ca(nx, lmu) = compressed coefficient values for each solution
+    ///  ia(nx) = pointers to compressed coefficients
+    ///  nin(lmu) = number of compressed coefficients for each solution
+    ///  rsq(lmu) = R**2 values for each solution
+    ///  alm(lmu) = lamda values corresponding to each solution
+    ///  nlp = actual number of passes over the data for all lamda values
+    ///    jerr = error flag:
+    ///  jerr = 0 => no error
+    ///  jerr > 0 => fatal error - no output returned
+    ///          jerr&lt; 7777 => memory allocation error
+    ///          jerr = 7777 => all used predictors have zero variance
+    ///          jerr = 10000 => maxval(vp) &lt;= 0.0
+    ///  jerr&lt; 0 => non fatal error - partial output:
+    ///  Solutions for larger lamdas (1:(k-1)) returned.
+    ///  jerr = -k => convergence for kth lamda value not reached
+    ///             after maxit(see above) iterations.
+    ///  jerr = -10000 - k => number of non zero coefficients along path
+    ///             exceeds nx(see above) at kth lamda value.
+    /// 
+    public static void elnet(
+      int ka,
+      double parm,
+      int no,
+      int ni,
+      double[,] x,
+      double[] y,
+      double[] w,
+      int[] jd,
+      double[] vp,
+      double[,] cl,
+      int ne,
+      int nx,
+      int nlam,
+      double flmin,
+      double[] ulam,
+      double thr,
+      int isd,
+      int intr,
+      int maxit,
+      // outputs
+      out int lmu,
+      out double[] a0,
+      out double[,] ca,
+      out int[] ia,
+      out int[] nin,
+      out double[] rsq,
+      out double[] alm,
+      out int nlp,
+      out int jerr
+      ) {
+      // initialize output values and allocate arrays big enough
+      a0 = new double[nlam];
+      ca = new double[nlam, nx];
+      ia = new int[nx];
+      nin = new int[nlam];
+      rsq = new double[nlam];
+      alm = new double[nlam];
+      nlp = -1;
+      jerr = -1;
+      lmu = -1;
+
+      // load correct version of native dll based on process (x86/x64)
+      if (Environment.Is64BitProcess) {
+        elnet_x64(ref ka, ref parm, ref no, ref ni, x, y, w, jd, vp, cl, ref ne, ref ni, ref nlam, ref flmin, ulam, ref thr, ref isd, ref intr, ref maxit, ref lmu, a0, ca, ia, nin, rsq, alm, ref nlp, ref jerr);
+      } else {
+        elnet_x86(ref ka, ref parm, ref no, ref ni, x, y, w, jd, vp, cl, ref ne, ref ni, ref nlam, ref flmin, ulam, ref thr, ref isd, ref intr, ref maxit, ref lmu, a0, ca, ia, nin, rsq, alm, ref nlp, ref jerr);
+      }
+      //  jerr = error flag:
+      //  jerr = 0 => no error
+      //  jerr > 0 => fatal error -no output returned
+      //  jerr < 7777 => memory allocation error
+      //          jerr = 7777 => all used predictors have zero variance
+      //  jerr = 10000 => maxval(vp) <= 0.0
+      //  jerr < 0 => non fatal error - partial output:
+      //      c Solutions for larger lamdas (1:(k - 1)) returned.
+      //  jerr = -k => convergence for kth lamda value not reached
+      //             after maxit(see above) iterations.
+      //          jerr = -10000 - k => number of non zero coefficients along path
+      //             exceeds nx(see above) at kth lamda value.
+      if (jerr != 0) {
+        if (jerr > 0 && jerr < 7777) throw new InvalidOperationException("glmnet: memory allocation error");
+        else if (jerr == 7777) throw new InvalidOperationException("glmnet: all used predictors have zero variance");
+        else if (jerr == 10000) throw new InvalidOperationException("glmnet: maxval(vp) <= 0.0");
+        else if (jerr < 0 && jerr > -1000) throw new InvalidOperationException(string.Format("glmnet: convergence for {0}th lamda value not reached after maxit iterations ", -jerr));
+        else if (jerr <= -10000) throw new InvalidOperationException(string.Format("glmnet: number of non zero coefficients along path exceeds number of maximally allowed variables (nx) at {0}th lamda value", -jerr - 10000));
+        else throw new InvalidOperationException(string.Format("glmnet: error {0}", jerr));
+      }
+
+
+      // resize arrays to the capacity that is acutally necessary for the results
+      Array.Resize(ref a0, lmu);
+      Array.Resize(ref nin, lmu);
+      Array.Resize(ref rsq, lmu);
+      Array.Resize(ref alm, lmu);
+    }
+
+    [DllImport("glmnet-x86.dll", EntryPoint = "elnet_", CallingConvention = CallingConvention.Cdecl)]
+    private static extern void elnet_x86(
+      ref int ka,
+      ref double parm,
+      ref int no,
+      ref int ni,
+      double[,] x,
+      double[] y,
+      double[] w,
+      int[] jd,
+      double[] vp,
+      double[,] cl,
+      ref int ne,
+      ref int nx,
+      ref int nlam,
+      ref double flmin,
+      double[] ulam,
+      ref double thr,
+      ref int isd,
+      ref int intr,
+      ref int maxit,
+      // outputs:
+      ref int lmu,
+      [Out] double[] a0,
+      [Out] double[,] ca,
+      [Out] int[] ia,
+      [Out] int[] nin,
+      [Out] double[] rsq,
+      [Out] double[] alm,
+      ref int nlp,
+      ref int jerr
+      );
+    [DllImport("glmnet-x64.dll", EntryPoint = "elnet_", CallingConvention = CallingConvention.Cdecl)]
+    private static extern void elnet_x64(
+      ref int ka,
+      ref double parm,
+      ref int no,
+      ref int ni,
+      double[,] x,
+      double[] y,
+      double[] w,
+      int[] jd,
+      double[] vp,
+      double[,] cl,
+      ref int ne,
+      ref int nx,
+      ref int nlam,
+      ref double flmin,
+      double[] ulam,
+      ref double thr,
+      ref int isd,
+      ref int intr,
+      ref int maxit,
+      // outputs:
+      ref int lmu,
+      [Out] double[] a0,
+      [Out] double[,] ca,
+      [Out] int[] ia,
+      [Out] int[] nin,
+      [Out] double[] rsq,
+      [Out] double[] alm,
+      ref int nlp,
+      ref int jerr
+      );
+
+
+    /// <summary>Wrapper for uncompress coefficient vector for particular solution in glmnet</summary>
+    /// (see: https://cran.r-project.org/web/packages/glmnet/index.html)
+    ///
+    /// call uncomp(ni, ca, ia, nin, a)
+    ///
+    /// input:
+    ///
+    ///    ni = total number of predictor variables
+    ///    ca(nx) = compressed coefficient values for the solution
+    /// ia(nx) = pointers to compressed coefficients
+    /// nin = number of compressed coefficients for the solution
+    ///
+    /// output:
+    ///
+    ///    a(ni) =  uncompressed coefficient vector
+    ///             referencing original variables
+    ///
+    public static void uncomp(int numVars, double[] ca, int[] ia, int nin, out double[] a) {
+      a = new double[numVars];
+      // load correct version of native dll based on process (x86/x64)
+      if (Environment.Is64BitProcess) {
+        uncomp_x64(ref numVars, ca, ia, ref nin, a);
+      } else {
+        uncomp_x86(ref numVars, ca, ia, ref nin, a);
+      }
+    }
+
+    [DllImport("glmnet-x86.dll", EntryPoint = "uncomp_", CallingConvention = CallingConvention.Cdecl)]
+    private static extern void uncomp_x86(ref int numVars, double[] ca, int[] ia, ref int nin, double[] a);
+    [DllImport("glmnet-x64.dll", EntryPoint = "uncomp_", CallingConvention = CallingConvention.Cdecl)]
+    private static extern void uncomp_x64(ref int numVars, double[] ca, int[] ia, ref int nin, double[] a);
+
+    public static void modval(double a0, double[] ca, int[] ia, int nin, int numObs, double[,] x, out double[] fn) {
+      fn = new double[numObs];
+      if (Environment.Is64BitProcess) {
+        modval_x64(ref a0, ca, ia, ref nin, ref numObs, x, fn);
+      } else {
+        modval_x86(ref a0, ca, ia, ref nin, ref numObs, x, fn);
+      }
+    }
+    // evaluate linear model from compressed coefficients and
+    // uncompressed predictor matrix:
+    //
+    // call modval(a0, ca, ia, nin, n, x, f);
+    //   c
+    //   c input:
+    //
+    //    a0 = intercept
+    //    ca(nx) = compressed coefficient values for a solution
+    // ia(nx) = pointers to compressed coefficients
+    // nin = number of compressed coefficients for solution
+    //    n = number of predictor vectors(observations)
+    // x(n, ni) = full(uncompressed) predictor matrix
+    //
+    // output:
+    //
+    //    f(n) = model predictions
+    [DllImport("glmnet-x86.dll", EntryPoint = "modval_", CallingConvention = CallingConvention.Cdecl)]
+    private static extern void modval_x86(ref double a0, double[] ca, int[] ia, ref int nin, ref int numObs, [Out] double[,] x, double[] fn);
+    [DllImport("glmnet-x64.dll", EntryPoint = "modval_", CallingConvention = CallingConvention.Cdecl)]
+    private static extern void modval_x64(ref double a0, double[] ca, int[] ia, ref int nin, ref int numObs, [Out] double[,] x, double[] fn);
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/HeuristicLab.Algorithms.DataAnalysis.Glmnet.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/HeuristicLab.Algorithms.DataAnalysis.Glmnet.csproj	(revision 14846)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/HeuristicLab.Algorithms.DataAnalysis.Glmnet.csproj	(revision 14846)
@@ -0,0 +1,198 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Algorithms.DataAnalysis.Glmnet</RootNamespace>
+    <AssemblyName>HeuristicLab.Algorithms.DataAnalysis.Glmnet-3.4</AssemblyName>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <AutoGenerateBindingRedirects>true</AutoGenerateBindingRedirects>
+    <TargetFrameworkProfile />
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+    <AllowUnsafeBlocks>true</AllowUnsafeBlocks>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup>
+    <StartupObject />
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <AllowUnsafeBlocks>true</AllowUnsafeBlocks>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <AllowUnsafeBlocks>true</AllowUnsafeBlocks>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
+    <OutputPath>..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Data.Linq" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Net.Http" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Plugin.cs.frame" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <Content Include="glmnet-license-gpl2.txt">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
+    <Content Include="glmnet-x64.dll">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
+    <Content Include="glmnet-x86.dll">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="ElasticNetLinearRegression.cs" />
+    <Compile Include="Glmnet.cs" />
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Algorithms.DataAnalysis\3.4\HeuristicLab.Algorithms.DataAnalysis-3.4.csproj">
+      <Project>{2e782078-fa81-4b70-b56f-74ce38dac6c8}</Project>
+      <Name>HeuristicLab.Algorithms.DataAnalysis-3.4</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Analysis\3.3\HeuristicLab.Analysis-3.3.csproj">
+      <Project>{887425b4-4348-49ed-a457-b7d2c26ddbf9}</Project>
+      <Name>HeuristicLab.Analysis-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
+      <Project>{958b43bc-cc5c-4fa2-8628-2b3b01d890b6}</Project>
+      <Name>HeuristicLab.Collections-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
+      <Project>{a9ad58b9-3ef9-4cc1-97e5-8d909039ff5c}</Project>
+      <Name>HeuristicLab.Common-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{c36bd924-a541-4a00-afa8-41701378ddc5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj">
+      <Project>{bbab9df5-5ef3-4ba8-ade9-b36e82114937}</Project>
+      <Name>HeuristicLab.Data-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding\3.4\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj">
+      <Project>{06D4A186-9319-48A0-BADE-A2058D462EEA}</Project>
+      <Name>HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
+      <Project>{14ab8d24-25bc-400c-a846-4627aa945192}</Project>
+      <Name>HeuristicLab.Optimization-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj">
+      <Project>{56F9106A-079F-4C61-92F6-86A84C2D84B7}</Project>
+      <Name>HeuristicLab.Parameters-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
+      <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
+      <Name>HeuristicLab.Persistence-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Symbolic.Regression\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic.Regression-3.4.csproj">
+      <Project>{5AC82412-911B-4FA2-A013-EDC5E3F3FCC2}</Project>
+      <Name>HeuristicLab.Problems.DataAnalysis.Symbolic.Regression-3.4</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Symbolic\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj">
+      <Project>{3D28463F-EC96-4D82-AFEE-38BE91A0CA00}</Project>
+      <Name>HeuristicLab.Problems.DataAnalysis.Symbolic-3.4</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj">
+      <Project>{df87c13e-a889-46ff-8153-66dcaa8c5674}</Project>
+      <Name>HeuristicLab.Problems.DataAnalysis-3.4</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.Instances\3.3\HeuristicLab.Problems.Instances-3.3.csproj">
+      <Project>{3540E29E-4793-49E7-8EE2-FEA7F61C3994}</Project>
+      <Name>HeuristicLab.Problems.Instances-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <PropertyGroup>
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+</PreBuildEvent>
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+export ProjectDir=$(ProjectDir)
+export SolutionDir=$(SolutionDir)
+
+$SolutionDir/PreBuildEvent.sh
+</PreBuildEvent>
+  </PropertyGroup>
+</Project>
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/HeuristicLab.Algorithms.DataAnalysis.Glmnet.sln
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/HeuristicLab.Algorithms.DataAnalysis.Glmnet.sln	(revision 14846)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/HeuristicLab.Algorithms.DataAnalysis.Glmnet.sln	(revision 14846)
@@ -0,0 +1,22 @@
+﻿
+Microsoft Visual Studio Solution File, Format Version 12.00
+# Visual Studio 14
+VisualStudioVersion = 14.0.25123.0
+MinimumVisualStudioVersion = 10.0.40219.1
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.DataAnalysis.Glmnet", "HeuristicLab.Algorithms.DataAnalysis.Glmnet.csproj", "{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}"
+EndProject
+Global
+	GlobalSection(SolutionConfigurationPlatforms) = preSolution
+		Debug|Any CPU = Debug|Any CPU
+		Release|Any CPU = Release|Any CPU
+	EndGlobalSection
+	GlobalSection(ProjectConfigurationPlatforms) = postSolution
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{4C7F6D8A-B279-4898-ACD6-7BE39111DEF9}.Release|Any CPU.Build.0 = Release|Any CPU
+	EndGlobalSection
+	GlobalSection(SolutionProperties) = preSolution
+		HideSolutionNode = FALSE
+	EndGlobalSection
+EndGlobal
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Plugin.cs.frame	(revision 14846)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Plugin.cs.frame	(revision 14846)
@@ -0,0 +1,48 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  /// <summary>
+  /// Plugin class for HeuristicLab.Algorithms.DataAnalysis.Glmnet plugin which wraps the glmnet implementation by Jerome Friedman, Trevor Hastie, Noah Simon, Rob Tibshirani, see https://cran.r-project.org/web/packages/glmnet/index.html
+  /// </summary>
+  [Plugin("HeuristicLab.Algorithms.DataAnalysis.Glmnet", "Plugin class for HeuristicLab.Algorithms.DataAnalysis.Glmnet plugin which wraps the glmnet implementation by Jerome Friedman, Trevor Hastie, Noah Simon, Rob Tibshirani, see https://cran.r-project.org/web/packages/glmnet/index.html", "3.4.1.$WCREV$")]
+  [PluginFile("HeuristicLab.Algorithms.DataAnalysis.Glmnet-3.4.dll", PluginFileType.Assembly)]
+  [PluginFile("glmnet-x86.dll", PluginFileType.NativeDll)]
+  [PluginFile("glmnet-x64.dll", PluginFileType.NativeDll)]
+  [PluginFile("glmnet-license-gpl2.txt", PluginFileType.License)]
+  [PluginDependency("HeuristicLab.Algorithms.DataAnalysis", "3.4")]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding", "3.4")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.4")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis.Symbolic", "3.4")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis.Symbolic.Regression", "3.4")]
+  public class HeuristicLabAlgorithmsDataAnalysisGlmnetPlugin : PluginBase {
+  }
+}
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/PreBuildEvent.cmd
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/PreBuildEvent.cmd	(revision 14846)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/PreBuildEvent.cmd	(revision 14846)
@@ -0,0 +1,2 @@
+IF EXIST "%ProjectDir%\Properties\AssemblyInfo.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
+IF EXIST "%ProjectDir%\Plugin.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Plugin.cs.frame" "%ProjectDir%\Plugin.cs"
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Properties/AssemblyInfo.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Properties/AssemblyInfo.cs.frame	(revision 14846)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/Properties/AssemblyInfo.cs.frame	(revision 14846)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+using HeuristicLab.PluginInfrastructure;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Algorithms.DataAnalysis.Glmnet")]
+[assembly: AssemblyDescription("Provides an interface to glmnet")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2016 HEAL, glmnet implementation by Jerome Friedman, Trevor Hastie, Noah Simon, Rob Tibshirani")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("34E747B1-2B80-41CE-9D0D-8D2827B09F91")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.4.0")]
+[assembly: AssemblyFileVersion("3.4.0.$WCREV$")]
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/glmnet-license-gpl2.txt
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/glmnet-license-gpl2.txt	(revision 14846)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/glmnet-license-gpl2.txt	(revision 14846)
@@ -0,0 +1,345 @@
+		    GNU GENERAL PUBLIC LICENSE
+		       Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.
+                       51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+			    Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software--to make sure the software is free for all its users.  This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it.  (Some other Free Software Foundation software is covered by
+the GNU Library General Public License instead.)  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have.  You must make sure that they, too, receive or can get the
+source code.  And you must show them these terms so they know their
+rights.
+
+  We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+
+  Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software.  If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary.  To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+
+		    GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term "modification".)  Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+  1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+  2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+
+  4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+  5. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+  6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+
+  8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+  9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+  10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+			    NO WARRANTY
+
+  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+		     END OF TERMS AND CONDITIONS
+
+
+	    How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+
+Also add information on how to contact you by electronic and paper mail.
+
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
+
+    Gnomovision version 69, Copyright (C) year name of author
+    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+  `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+  <signature of Ty Coon>, 1 April 1989
+  Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs.  If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library.  If this is what you want to do, use the GNU Library General
+Public License instead of this License.
